## Getting Started

In order to trigger a release pipeline, the `VERSIONS` variable in file
`versions.yml` need to be set to the versions that need to be built.

If the variable is empty, the pipeline will **NOT** run.

For example, change the variable to this in order to build version `0.1.2.3`
and `0.2.3.4`:

```yaml
variables:
  VERSIONS: "0.1.2.3 0.2.3.4"
```

For multiple versions, add them whitespace separated.

Only versions that have a corresponding core/tor `release-*` branch will be
built. For non-stable versions, `main` is used and the major version need to
match the one in the `configure.ac`. See `pre-validation.sh` for the version
rules and how it preps the pipeline.

## Pipeline Stages

There are four stages to this release pipeline. Some jobs in the stages are
only triggered manually because they require a human to do some work before
they can run. The following sections explains them in details.

### Preliminary

This stage is about validation and preparing for build process.

Only one job exists and it is the validation process. That job will validate
the `VERSIONS` variable (from `versions.yml`) and find its associated release
branch from core/tor repository.

  1. `validation`: Creates one file per version to build (file name is the
     version) containing the git branch to release from. (auto)

#### Artifacts

Generated version files will be in `artifacts/versions/`.

### Patches

This stage is designed to generate core/tor git patches that need to be
applied on the tor repository before the `Build` stage.

There are currently 3 jobs which are:

  1. `fallbackdirs`: Generates the fallback directory list for both core/tor and
     core/arti. (auto)

  2. `geoip`: Generates the GeoIP database both for core/tor and core/arti.
     (auto)

  3. `changes-version`: Bump the versions and construct the ChangeLog and
     ReleaseNotes. This job depends on (1) and (2) above before it can starts
     since it will use the changes file from them. (auto)

#### Artifacts

At the very end of the stage, the artifacts generated are in
`artifacts/patches/` and sorted in directories like so:

  - `arti`: Patches that need to be applied on core/arti.

  - `maint`: Patches that need to be applied on **all** maintained versions
    that is in all `maint-` branches and merged forward.

  - `maint-x.y.z`: Patches that need to be applied only on that branch and
    merged with `-s ours`.

  - `release-x.y.z`: Patches that need to be applied only on the release
    branch.

### Build

This stage actually builds the tarball(s).

Only one job exists and it is a manual job as in it needs to be triggered
manually. The reason for this is because a human needs review and merge all
patches generated by the `Patches` stage.

  1. `maintained`: Builds the tarballs in a reproducible way and must be
     triggered manually when the upstream repository has everything needed
     from the previous build. (manual)

While this stage is running, the several member of the Network Team need to
build and sign the tarballs generated in a reproducible way using the Tor CI
Reproducible repository. Then then upload the signature to it. The next stage
will then use those to verify the tarball(s).

#### Artifacts

The tarballs can be found in `artifacts/tarballs` once the `maintained` job is
over.

### Post-Process

This stage finalizes the release process by generating two things through two
jobs: version patches (bumping to -dev) and tarball signatures.

  1. `patches`: Generates the patches that need to be applied after the
     tarballs are released. (auto)

  2. `signatures`: Takes all signatures for each versions from the Tor CI
     Reproducible repository and verifies them against the generated
     tarball(s) from the `Build` stage. If everything verifies, a signature is
     generated by concatening all signatures into one `.asc` file. (manual)

The job (2) is manual because it requires that all signatures be in the Tor CI
Reproducible repository before this can be run thus a human needs to trigger
it.

#### Artifacts

In `artifacts/tarballs`, the resulting tarball(s) and signature(s) will be
located in there and they can safely be released to the public.

## Network Team Keys

The directory `gpg/network-team-keys/` contains the GPG key of the network
team members that are involved in the reproducible build process and
validating the generated tarballs(s).

These keys can also be used to verify the release once public. We put them in
here manually in order to avoid the CI to depends on the unreliability of GPG
key servers.
